start cstat(lib);
dsn=datasets(lib);
run quelvnum(vdat,dsn);
call execute("use ", lib,".",vdat,";");
nomv=contents();
run quelvars(vobs,nvar,nomv);
read all var nvar into e;
read all var vobs into vdent;
close;
if type(vdent)='N' then vdent=char(vdent,taille(max(vdent)));
run quelclas(cdat,dsn);
call execute("use ", lib,".",cdat,";");
nomc=contents();
run quelvcl(cobs,cvar,nomc);
read all var cvar into class;
read all var cobs into cdent;
close;
if type(cdent)='N' then cdent=char(cdent,taille(max(cdent)));
if ncol(setdif(vdent,cdent))>0 | ncol(setdif(cdent,vdent))>0
then    do;
print "  " /;
print "_________________________________________________";
print "               PROBLEME DE COHERENCE             ";
print "Pour les valeurs qui identifient les observations";
print "_________________________________________________";
print cdent vdent;
abort;
        end;
nclass=ncol(unique(class));
run lunivar(valeur,e,class,nvar);
run lanova(anova,e,class,nvar);
run manova(test,e,class);
cvar=trim(left(cvar));
if length(cvar)<5 then cvar=concat(cvar,cshape('X',1,1,5-length(cvar)));
fstat=concat(substr(upcase(cvar),1,5),'_ST');
call execute('reset storage=',lib,'.',fstat,';');
remove _all_; store _all_;
idl_moy=char(unique(class),taille(max(unique(class))))||"all";
idv_moy='EFFECTIF'//nvar;
fstd=concat(upcase(substr(cvar,1,4)),'_MOY');
if nclass^=1 then run tablesas(lib,fstd,valeur,idv_moy,idl_moy);
idl_ano='SC_INTER'//'SC_INTRA'//'SC_TOTAL'//'FISHER'//'P_VALUE';
idv_ano='DL'//nvar;
fano=concat(upcase(substr(cvar,1,4)),'_ANO');
if nclass^=1 then run tablesas(lib,fano,anova,idv_ano,idl_ano);
idl_man='WILKS'//'HOTELLING';
idv_man='VALEUR'//'KHI2'//'DL'//'P_VALUE';
fman=concat(upcase(substr(cvar,1,4)),'_MAN');
if nclass^=1 then run tablesas(lib,fman,test,idv_man,idl_man);
finish cstat;
store module=cstat;
