start dgril;
run grigri(m,n,tmax,periode);
nu=m*n; eps0=.3; c0=.2;
ws=j(2,nu,0); w=10*uniform(j(2,nu,0))-5;
run affich(w,m,n,0,tmax,0);
do t=1 to tmax;
  x=10*uniform(j(2,1,0))-5;
  k=sqrt((w-repeat(x,1,nu))[##,])[>:<];
  epst=eps0/(1+c0*t/nu);
  r=radius(m,n,tmax,t);
  if r>.5  then v=grivois(k,m,n,r);
  if r=.5  then v=voisgdmi(k,m,n);
  if r=0   then v=k;
  ws=w;
  do j=1 to nrow(v)*ncol(v);
    ws[,v[j]]=w[,v[j]]+epst*(x-w[,v[j]]);
  end;
  if mod(t,periode)=0 then run affich(ws,m,n,t,tmax,r);
  w=ws;
end;
finish dgril;
store module=dgril;
