start kofdisj(lib,e,idlig,idcol);
label=idlig//idcol; modal=idlig;
run ficelle(n,tmax,crnd,cener); nu=n; run declar(cat,cdd);
if length(cat)<5 then cat=concat(cat,cshape('X',1,1,5-length(cat)));
if crnd='O' then seed=2112; else seed=0;
p=nrow(e); q=ncol(e);
wp0=uniform(j(p,nu,seed)); wq0=uniform(j(q,nu,seed));
ec=pkor(e); el=pkor(e`);
	/* wp0 et wq0 initialises dans les entrees ec et el */
		/* si nu<=q (nbre d'individus) */
/*
on tire nu individus dans ec (q individus)  pour wp0
wq0 est forme par leurs modalites (el: p modalites) les plus rares
*/
if nu<=q then
do; tir=tir(nu,q,seed); wp0=ec[,tir];
 do j=1 to nu; wq0[,j]=el[,ec[,tir[j]][<:>]]; end; end;
		/* si nu>q (nbre d'individus) */
/*
on prend tout ec et on complete dans l'tendue pour wp0
wq0 est par les modalits associees et complete dans l'etendue
*/
if nu>q then
	do;
wp0[,1:q]=ec; do j=1 to q; wq0[,j]=el[,ec[,j][<:>]]; end;
minec=min(ec); maxec=max(ec); minel=min(el); maxel=max(el);
wp0[,q+1:nu]=uniform(j(p,nu-q,seed))*(maxec-minec)+minec;
wq0[,q+1:nu]=uniform(j(q,nu-q,seed))*(maxel-minel)+minel;
	end;
if cener='O' then run kdafcnf(pot,wp,wq,e,wp0,wq0,nu,tmax);
if cener='N' then run kdafcf(wp,wq,e,wp0,wq0,nu,tmax);
codp=codbk(wp,ec,nu); codq=codbk(wq,el,nu); ccod=codq//codp; code=ccod;
iclp=unique(codp)`; iclq=unique(codq)`; icl=unique(ccod)`;
bigws=wp//wq; eff=rconte(ccod,nu);
				dubig=max(nrow(wp),nrow(wq));	ws=wp;	dimw=nrow(ws);
		/* construction de la table <<cat>> */
D=e`;  B=e*D; x=ccod||(B//D); nacol='_codage_'//label;
run tablesas(lib,cat,x,nacol,label);
	/* construction de la table <<CL>> */
fcla=concat(substr(cat,1,5),'_CL');
run prepar(rep,nvar,nobs,ccod,eff,icl,label);
if max(eff)<=50 then run tablesas(lib,fcla,rep,nvar,nobs);
		else run tablesas(lib,fcla,rep`,nobs,nvar);
	/* construction de la table <<WS>> */
fws=concat(substr(cat,1,5),'_WS');
cell=char(j(nu,1,0)); do k=1 to nu; cell[k]=concat("No",char(k,taille(nu))); end;
pdf=eff||ws`; yvc='effectif'//label; run tablesas(lib,fws,pdf,yvc,cell);
titdisj=concat('KDISJ : ficelle ',trim(left(char(nu))),
			' pour ',trim(left(char(tmax))),' iterations');
act=titdisj; titp='Representants (Poids Finaux) pour les individus';
titq='Representants (Poids Finaux) pour les modalites';
gkat=concat(lib,'.gacm',substr(cat,1,4));
	/* construction du catalogue iml */
call execute("reset storage=",lib,".",cat,";");
remove _all_; store _all_; remove nacol yvc x pdf k seed;
	/* construction du catalogue graphique */
if nu>50 then print "pas de graphique pour une ficelle de plus de 50 unites";
	/* construction du catalogue graphique */
if nu>10 & nu<=50  then do;  run filpav(code,label,nu,gkat,titdisj);
			     run filpav(codq,idlig,nu,gkat,titdisj);
			     run frik(wp,codp,nu,gkat,0);
			     run fcellw(el,wp,codp,nu,gkat);
if dubig<=50  then do;	run linfic(wp,1:ncol(wp),nu,gkat,titp,idlig,0);
			run linfic(wq,1:ncol(wq),nu,gkat,titq,idcol,0);
		   end;
			end;
if nu<=10  then do; run filpa10(code,label,nu,gkat,titdisj);
		    run filpa10(codq,idlig,nu,gkat,titdisj);
		    run frik10(wp,codp,nu,gkat,0);
		    run fcellw10(el,wp,codp,nu,gkat);
if dubig<=50  then do;	run linf10(wp,1:ncol(wp),nu,gkat,titp,idlig,0);
			run linf10(wq,1:ncol(wq),nu,gkat,titq,idcol,0);
		   end;
		end;
if cdd='O' then  do; run ddwf(wp,iclp,'DX-DY pour les individus',gkat,0);
		     run ddwf(wq,iclq,'DX-DY pour les modalites',gkat,0);
		 end;
if cener='O' then  do;
       call gstart(gkat,0);
       run grol(pot[,1],'Variance intra etendue aux voisins pour les individus');
       run grol(pot[,2],'Variance intra etendue aux voisins pour les modalites');
       call gstop; end;
finish kofdisj;
store module=kofdisj;
