start lanova(anova,x,fact,idvar);
/* intra=residuelle=Within  inter=expliquee=Between */
/* total=intra + inter                            */
n=nrow(x); lf=nrow(fact)*ncol(fact); if n^=lf then return;
p=ncol(x); lv=nrow(idvar)*ncol(idvar); if p^=lv then return;
anova=j(5,p+1);
sinter=j(1,p,0); sintra=sinter; stotal=sinter;
fisher=sinter; pval=sinter;
fa=unique(fact); nfa=ncol(fa);
if nfa=1 then
do;
   print " "/; print " PROBLEME : un unique groupe ";
   abort;
end;
dfintra=n-nfa; dfinter=nfa-1; dftotal=n-1;
ecartf=j(n,p,0); ecart=ecartf;
binf=1;
do k=1 to nfa;
      z=x[loc(fact=fa[k]),];
      l=nrow(z);
      bsup=binf+l-1;
      ecartf[binf:bsup,]=z-repeat(z[:,],l,1);
      binf=bsup+1;
end;
intra=ecartf`*ecartf; sintra=diag(intra)[+,];
ecart=x-repeat(x[:,],n,1);
total=ecart`*ecart; stotal=diag(total)[+,];
inter=total-intra;  sinter=diag(inter)[+,];
fisher=sinter/sintra*dfintra/dfinter;
do j=1 to p;
        pval[j]=1-probf(fisher[j],dfinter,dfintra);
end;
linter=dfinter||sinter; lintra=dfintra||sintra;
ltotal=dftotal||stotal; lfisher={.}||fisher; lpval={.}||pval;
anova=linter//lintra//ltotal//lfisher//lpval;
idl='SC_INTER'//'SC_INTRA'//'SC_TOTAL'//'FISHER'//'P_VALUE';
idv='DL'//idvar;
print "ANALYSE DE LA VARIANCE";
print anova[rowname=idl colname=idv];
finish lanova;
store  module=lanova;
