start llofic(e,ident,lib,idvar);
/* p= nbre d'observations, q=nbre de variables */
p=nrow(e); q=ncol(e); if p<q then do; print "  ";
	    print "_______________________________________________________";
	    print "	 >>>>>	 AVERTISSEMENT				  ";
	    print "le nombre de variables depasse le nombre d'observations";
	    print "_______________________________________________________";
	    end;
run ficelle(n,tmax,crnd,cener); run declar(cat,cdd);
run initw0(cint); run pretrait(cpre); nu=n;  dimw=q;
if crnd='O' then seed=1212; else seed=0; w0=uniform(j(q,nu,seed));
if cint='H' & nu<=p then tir=tir(nu,p,seed);	
if cpre='A' then ee=e`;  
if cpre='C' then ee=centr(e)`; 
if cpre='N' then ee=cered(e)`; 
if cpre='K' then ee=diki(e`); 
if cint='E' then do; max=max(ee); min=min(ee); w0=w0*(max-min)+min; end;
if cint='H' & nu<=p then w0=ee[,tir];
if cint='H' & nu>p  then 
	do;	max=max(ee); min=min(ee); 
		w0[,1:p]=ee; 
		w0[,p+1:nu]=uniform(j(q,nu-p,seed))*(max-min)+min;
	end;
if cint='F' & cpre='A' then w0=facbruf(e,nu);
if cint='F' & cpre='C' then w0=facenf(e,nu);
if cint='F' & cpre='N' then w0=facnorf(e,nu);
if cint='F' & cpre='K' then w0=facbruf(ee`,nu);
if cener='O' then run llofn1(pot,ws,ee,w0,n,tmax);
if cener='N' then ws=llof1(ee,w0,n,tmax);
code=codbk(ws,ee,n); label=ident;
eff=rconte(code,n);
if cpre='K' then do; el=prolig(e); run promy(icl,pfm,code,el,n); end;
	    else run promy(icl,pfm,code,e,n);
if length(cat)<5 then cat=concat(cat,cshape('X',1,1,5-length(cat)));
gkat=concat(lib,'.gacp',substr(cat,1,4));
fws=concat(substr(cat,1,5),'_WS');
fug=concat(substr(cat,1,5),'_UG');
fcla=concat(substr(cat,1,5),'_CL');
run prepar(rep,nvar,nobs,code,eff,icl,ident);
centr=pfm`; mono=cered(centr)`;
cell=char(j(nu,1,0));
do k=1 to nu; cell[k]=concat("No",char(k,taille(nu))); end;
pdf=eff||ws`;
yvc='effectif'//idvar;
if cpre='A' then do;
		     ivc='_codage_'//idvar;
		     x=code||ee`;  zidvar=' ';
		 end;
	    else do;
		     zidvar=concat('Z',idvar);
		     ivc='_codage_'//idvar//zidvar;
		     x=code||e||ee`;
		 end;
if max(eff)<=50 then run tablesas(lib,fcla,rep,nvar,nobs);
		else run tablesas(lib,fcla,rep`,nobs,nvar);
run tablesas(lib,fws,pdf,yvc,cell);
run tablesas(lib,fug,centr,idvar,nobs);
run tablesas(lib,cat,x,ivc,ident);
titacp=concat('KFAST : ficelle de ',trim(left(char(nu))),
	      ' pour ',trim(left(char(tmax))),' iterations');
act='KACP : ficelle';
titug='Moyennes des classes (valeurs normalisees)';
titws='Representants des classes (Poids Finaux)';
call execute("reset storage=",lib,".",cat,";");
remove _all_; store _all_; remove ivc yvc x k pdf centr mono nvar seed zidvar;
if nu>50 then print "pas de graphique pour une ficelle de plus de 50 unites";
if nu > 10 & nu <= 50 then
  do;
	run filpav(code,ident,nu,gkat,titacp);
	run frikmaha(ee,ws,code,eff,nu,gkat,1);
	if dimw<=50  then
		do;
		   run linfic(ws,1:ncol(ws),nu,gkat,titws,idvar,0);
		   run hisfic(ws,1:ncol(ws),nu,gkat,titws,idvar,0);
		   if cpre='K' then
			do;
			  run linfic(pfm,icl,nu,gkat,titug,idvar,0);
			  run hisfic(pfm,icl,nu,gkat,titug,idvar,0);
			end;
			       else
			do;
			  run linfic(mono,icl,nu,gkat,titug,idvar,0);
			  run hisfic(mono,icl,nu,gkat,titug,idvar,0);
			end;
		end;
  end;
if nu <= 10  then
  do;
	run filpa10(code,ident,nu,gkat,titacp);
	run frik10ma(ee,ws,code,eff,nu,gkat,1);
	if dimw<=50  then
		do;
		   run linf10(ws,1:ncol(ws),nu,gkat,titws,idvar,0);
		   run hisf10(ws,1:ncol(ws),nu,gkat,titws,idvar,0);
		   if cpre='K' then
			do;
			  run linf10(pfm,icl,nu,gkat,titug,idvar,0);
			  run hisf10(pfm,icl,nu,gkat,titug,idvar,0);
			end;
			       else
			do;
			  run linf10(mono,icl,nu,gkat,titug,idvar,0);
			  run hisf10(mono,icl,nu,gkat,titug,idvar,0);
			end;
		end;
  end;
if cdd='O' then run ddwf(ws,icl,'DX-DY',gkat,1);
if cener='O' then  do; 
call gstart(gkat,1); run grol(pot,'Variance intra etendue aux voisins');
call gstop;        end;
finish llofic;
store module=llofic;

