%*libname k 'c:\k7\akor';
options nocenter nodate ls=120  ps=500 mprint SASMSTORE=k mstored;
%window obsclust  rows=25  color=cyan
#1 @20 "Pour abandonner taper O dans le champ STOP =" +1 stop 1 attr=rev_video
#3 @20 "COMPLEMENT KACP, KFAST, KBATCH POUR TOUTE STRUCTURE" color=magenta
#4 @20 "=>>> OBSERVATIONS DANS LES CLUSTERS (super_classes)"  attr=underline
#6 @3 "nom de la librairie  (par defaut c:\k7\aboul) "
#7 @3 "nom commun           (par defaut _TEMPOR_) "
#8 @3 "nombre de clusters   (le nombre de super-classes de MKLUG, MKLUFj j=1,2)"
#11 @10 "librairie  :" +2 lib   40 attr=rev_video
#13 @10 "nom commun :" +2 nom  8 attr=rev_video
#15 @10 "nombre de clusters :" +2 nc 2 attr=rev_video
#19 @63 "Valider vos choix avec la touche F3" color=magenta
#20 @37 "En cas de NON sortie consulter les messages de la fenetre LOG "
         color=magenta;
%macro mklobs / store des="observations dans les clusters";
%local nom lib stop tabn tabws taclus tacluf catiml ok nc ok1 ok2 ok3 ok4;
%let err=0; %let stop=; %let lib=c:\k7\aboul; %let nom=_TEMPOR_; %let nc=;
%let ok=0; %let ok1=0; %let ok2=0; %let ok3=0; %let ok4=0;
%do %until(&ok=1);
%display obsclust;
%let stop=%upcase(&stop); %if &stop=  %then %let ok1=1;
%if &stop=O %then %goto arret;
%if &stop^=O and &stop^=  %then
%do; %let ok1=0; %put ne taper pas  &stop mais O pour abandonner; %goto test; %end;
%str(libname a "&lib";);
%if  (%sysfunc(libref(a))) %then %put %str(le repertoire &lib n%'existe pas !);
%let nom=%upcase(&nom);
%if %length(&nom)<5
%then  %do j=1 %to %eval(5-%length(&nom)); %let nom=&nom.X; %end;
%let catiml=a.&nom;
%if  %sysfunc(cexist(&catiml)) %then %let ok2=1;
                               %else
%do; %put %str(le catalogue iml &catiml n%'existe pas !); %let ok2=0; %end;
%let tabn=a.&nom;
%let taclus=a.CLUST&nc;
%let tacluf=a.CLUSF&nc;
%if  %sysfunc(exist(&taclus)) or %sysfunc(exist(&tacluf))
%then %let ok3=1; %else %do;
%put %str(ou bien la table &taclus n%'existe pas !);
%put %str(ou bien la table &tacluf n%'existe pas !);
%let ok3=0;             %end;
%let tabws=a.%substr(&nom,1,5)_WS; %if  %sysfunc(exist(&tabws)) %then %let ok4=1;
     %else %do; %put %str(la table sas &tabws n%'existe pas !); %let ok4=0; %end;
%test: %put %str();
%if &ok1=1 and &ok2=1 and &ok3=1 and &ok4=1  %then %let ok=1;
%else %do; %let stop=; %let lib=c:\k7\aboul; %let nom=_TEMPOR_; %let nc=; %end;
%end;
%str(libname a "&lib";);
libname k 'c:\k7\akor';
proc contents data=&tabws out=out noprint;
data out; set out; keep name varnum;
proc sql noprint; select varnum  into :vf from out
                                where  upcase(name)='EFFECTIF'; quit;
%if &vf=4 %then %let taclu=&taclus;
%if &vf=2 %then %let taclu=&tacluf;
data ff; set &tabn; run;
data x; set &taclu; num=_n_; keep cluster num; run;
proc sql;
create table cc as select cluster, idobs, _codage_
from x, ff where num=_codage_; quit;
proc sql;
create table bug as select max(cluster) as nbgr from x; quit;
proc iml;
use cc; noms=contents(); idcl=noms[1]; read all var idcl into group; close;
use bug; read all var _num_ into nbgp; close;
reset storage=&catiml; load;
reset storage=k.kouto;
load module=(obsclu10 obsclu);
if dimw<=50
  then do;
if nbgp <=10 then run obsclu10(ee`,group,nbgp,gkat);
if nbgp >10 & nbgp <=50 then run obsclu(ee`,group,nbgp,gkat);
        end;
  else print 'Pas de graphique si dimW>50';
quit;
%arret : %put FIN DE LA MACRO;
%mend mklobs;
