%*libname k 'c:\k7\akor';
options nocenter nodate ls=78  ps=200 mprint SASMSTORE=k mstored;
%window escalclu  rows=29 color=cyan
#1 @20 "Pour abandonner taper O dans le champ STOP =" +1 stop 1 attr=rev_video
#3 @20 "COMPLEMENTS TOUT PROGRAMME TOUTE STRUCTURE" color=magenta
#4 @20 "=>>> SCALING EUCLIDIEN DES UNITES GAGNANTES AVEC VISION DES CLUSTERS"
	attr=underline
#6 @3 "nom de la librairie	   (par defaut c:\k7\aboul) "
#7 @3 "nom commun		   (par defaut _TEMPOR_) "
#8 @3 "type du catalogue     (3 solutions pour ???? : GACP ou GKOR ou GACM)"
#9 @3 "nombre de clusters    (le nombre de super-classes de MKLUG, MKLUFj j=1,2) "
#10 @3 "Si le nombre de clusters est >=23 il faut utliser la macro MSCAL"
       color=magenta
#13 @10 "librairie  :" +2 lib 40 attr=rev_video
#15 @10 "nom commun :" +2 nom  8 attr=rev_video
#17 @10 "type du catalogue :" +2 typ 4 attr=rev_video
#19 @10 "nombre de clusters :" +2 nc 2 attr=rev_video
#23 @63 "Valider vos choix avec la touche F3" color=magenta
#24 @37 "En cas de NON sortie consulter les messages de la fenetre LOG "
	 color=magenta;
%macro mscol / store des="Scaling Euclid. des gagnants + clusters";
%local lib nom typ stop tabws taclus tacluf catiml tad gcat ok ok1 ok2 ok3 ok4 ok5 ok6;
%let stop=; %let lib=c:\k7\aboul; %let nom=_TEMPOR_; %let typ=????; %let ok=0;
%let ok1=0; %let ok2=0; %let ok3=0; %let ok4=0; %let ok5=0; %let ok6=0; %let nc=;
%do %until(&ok=1);
%display escalclu;
%let stop=%upcase(&stop); %if &stop=  %then %let ok4=1;
%if &stop=O %then %goto arret;
%if &stop^=O and &stop^=  %then
%do; %let ok4=0; %put ne taper pas &stop mais O pour abandonner; %goto test; %end;
%str(libname a "&lib";);
%if (%sysfunc(libref(a))) %then %put %str(le repertoire &lib n%'existe pas !);
%let nom=%upcase(&nom); %if %length(&nom)<5
%then  %do j=1 %to %eval(5-%length(&nom)); %let nom=&nom.X; %end;
%let catiml=a.&nom;
%if %sysfunc(cexist(&catiml)) %then %let ok1=1;
%else %do; %put %str(le catalogue iml &catiml n%'existe pas !); %let ok1=0; %end;
%let typ=%upcase(&typ);
%if &typ=GACP or &typ=GACM or &typ=GKOR %then %let ok2=1; %else %let ok2=0;
%let gcat=a.&typ%substr(&nom,1,4);
%if %sysfunc(cexist(&gcat)) %then %let ok3=1;
%else %do; %put %str(le catalogue graphique &gcat n%'existe pas !); %let ok3=0; %end;
%let taclus=a.CLUST&nc; %let tacluf=a.CLUSF&nc;
%if  %sysfunc(exist(&taclus)) or %sysfunc(exist(&tacluf))
%then %let ok5=1; %else %do;
%put %str(ou bien la table &taclus n%'existe pas !);
%put %str(ou bien la table &tacluf n%'existe pas !);
%let ok5=0;		%end;
%let tabws=a.%substr(&nom,1,5)_WS; %if	%sysfunc(exist(&tabws)) %then %let ok6=1;
     %else %do; %put %str(la table sas &tabws n%'existe pas !); %let ok6=0; %end;
%test: %put %str();
%if &ok1=1 and &ok2=1 and &ok3=1 and &ok4=1 and &ok5=1 and &ok6=1 %then %let ok=1;
%else %do;
%let stop=; %let lib=c:\k7\aboul; %let typ=????; %let nom=_TEMPOR_; %let nc=; %end;
%end;
%if &nc>22 %then  %goto arret;
%str(libname a "&lib";); libname k 'c:\k7\akor';
proc contents data=&tabws out=ot noprint;
data ot; set ot; keep name varnum;
proc sql noprint; select varnum  into :vf from ot
					where upcase(name)='EFFECTIF'; quit;
%if &vf=4 %then %let taclu=&taclus;  %if &vf=2 %then %let taclu=&tacluf;
proc iml;
reset storage=k.kompa; load module=taille;
reset storage=k.kouto; load module=deug; reset storage=&catiml; load;
%let tad=%substr(&catiml,3,5); %let tad=&tad._EG;
run deug('a','&tad',ws,icl);
quit;
proc contents data=a.&tad out=oo noprint;
data oo; set oo; keep name varnum;
proc sql noprint; select max(varnum)  into :nug  from oo ; quit;
%if &nug<=3 %then %do;
%put Il faut au moins 3 unites gagnantes pour le MDS; %goto arret; %end;
proc mds data=a.&tad level=a out=e nop; id cell; run;
data ee; set e(firstobs=2 keep=cell dim1 dim2);
data e2; set ee; ccell=compress(cell);
data taclu; set &taclu; iidobs=compress(idobs);
proc sql; create table eg2 as
select cluster, e2.* from taclu, e2
where ccell=iidobs; quit;
data eg; set eg2(keep=cluster cell dim1 dim2);
data anne; set eg;
length color $8;
retain xsys ysys '2';
text=cell; x=dim1; y=dim2;
function='label';
if cluster=1 then color='lipk' ; if cluster=2 then color='vliv' ;
if cluster=3 then color='lig' ;  if cluster=4 then color='vlibg' ;
if cluster=5 then color='lio' ;  if cluster=6 then color='ligr' ;
if cluster=7 then color='rose' ; if cluster=8 then color='steel' ;
if cluster=9 then color='paoy' ; if cluster=10 then color='vligb' ;
if cluster=11 then color='ligrpr'; if cluster=12 then color='vpav' ;
if cluster=13 then color='lippk' ; if cluster=14 then color='liybr' ;
if cluster=15 then color='paypk' ; if cluster=16 then color='lilg' ;
if cluster=17 then color='lilac' ; if cluster=18 then color='vpag' ;
if cluster=19 then color='brown' ; if cluster=20 then color='pink' ;
if cluster=21 then color='liolgr'; if cluster=22 then color='libg' ;
size=1.125; style='swissb';
run;
%if &vf=4 %then 	%do;
proc gplot annotate=anne gout=&gcat; symbol v=none I=none;
plot y*x / name='ESCALCLU' fr des='Scaling (E) des Gagnants + Clusters';
title j=c h=2 c=red f=swissb " SCALING (E) et CLUSTERS en 2D ";
run; title; quit;	%end;
%if &vf=2 %then 	%do;
proc gplot annotate=anne gout=&gcat; symbol v=none I=join CI=black W=1;
plot y*x / name='ESCALCLU' fr des='Scaling (E) des Gagnants + Clusters';
title j=c h=2 c=red f=swissb " SCALING (E) et CLUSTERS en 2D ";
run; title; quit;	%end;
%arret : %put FIN DE LA MACRO;
%mend mscol;
