start kofacm2(lib,B,modal,D,idlig);
ident=modal//idlig;    label=ident;
run ficelle(n,tmax,crnd,cener); nu=n; run declar(cat,cdd);
if length(cat)<5 then cat=concat(cat,cshape('X',1,1,5-length(cat)));
if crnd='O' then seed=1212; else seed=0;
w0=uniform(j(ncol(B),nu,seed));  dimw=ncol(B);
ee=pkor(B); Dc=(D/D[1,+])`;
max=max(ee); min=min(ee); w0=w0*(max-min)+min;
if cener='O' then run kofoen1(pot,ws,ee,w0,n,tmax);
if cener='N' then ws=kofoe1(ee,w0,n,tmax);
codB=codbk(ws,ee,nu); codD=codbk(ws,Dc,nu);
ccod=codB//codD; icl=unique(ccod)`; eff=rconte(ccod,nu); code=ccod;
        /* construction de la table <<cat>> */
x=ccod||(B//D);
mo=char(j(ncol(D),1,0)); ob=char(j(nrow(D),1,0));
do j=1 to ncol(D); mo[j]=concat("mo",char(j,taille(ncol(D))),"="); end;
do j=1 to nrow(D); ob[j]=concat("ob",char(j,taille(nrow(D))),"="); end;
_type_=concat(trim(left((mo//ob))),ident); nacol='_codage_'//modal;
run tablesas(lib,cat,x,nacol,_type_);
        /* construction de la table <<CL>> */
fcla=concat(substr(cat,1,5),'_CL');
run prepar(rep,nvar,nobs,ccod,eff,icl,ident);
if max(eff)<=50 then run tablesas(lib,fcla,rep,nvar,nobs);
                else run tablesas(lib,fcla,rep`,nobs,nvar);
        /* construction de la table <<WS>> */
fws=concat(substr(cat,1,5),'_WS'); cell=char(j(nu,1,0));
do k=1 to nu; cell[k]=concat("No",char(k,taille(nu))); end;
pdf=eff||ws`; yvc='effectif'//modal;
run tablesas(lib,fws,pdf,yvc,cell);
titacm=concat('KACM2 : ficelle de ',trim(left(char(nu))),
                     ' pour ', trim(left(char(tmax))),' iterations');
act=titacm; titws='Representants des classes (Poids Finaux)';
gkat=concat(lib,'.gacm',substr(cat,1,4));
        /* construction du catalogue iml */
call execute("reset storage=",lib,".",cat,";");
remove _all_; store _all_; remove nacol x pdf yvc k j mo ob seed;
if nu>50 then print "pas de graphique pour une ficelle de plus de 50 unites";
        /* construction du catalogue graphique */
if nu>10 & nu<=50 then
        do; run filpav(ccod,ident,nu,gkat,titacm);
            run filpav(codB,modal,nu,gkat,titacm);
            run frikmaha(ee,ws,codB,eff,nu,gkat,1);
if dimw<=50 then run linfic(ws,1:ncol(ws),nu,gkat,titws,modal,1);  end;
if nu<=10 then
        do; run filpa10(ccod,ident,nu,gkat,titacm);
            run filpa10(codB,modal,nu,gkat,titacm);
            run frik10ma(ee,ws,codB,eff,nu,gkat,1);
if dimw<=50 then run linf10(ws,1:ncol(ws),nu,gkat,titws,modal,1);  end;
if cdd='O' then run ddwf(ws,icl,'DX-DY',gkat,1);
if cener='O' then do; call gstart(gkat,1);
   run grol(pot,'Variance intra etendue aux voisins');call gstop; end;
finish kofacm2;
store module=kofacm2;
