start cluscoz(outtree,m,n,gkat,titre);
call execute('use ',outtree,' var {idobs cluster clusname};');
read all; close;
if 95/m-int(95/m)>=.5 then pv=int(95/m)+.5; else pv=int(95/m);
if 100/n-int(100/n)>=.5 then ph=int(100/n)+.5; else ph=int(100/n);
xbox={0 0 1 1}; ybox={0 1 1 0};
colors={'lipk','vliv','lig','vlibg','lio','ligr','rose','steel',
        'paoy','vligb','ligrpr','vpav','lippk','liybr','paypk','lilg',
        'lilac','vpag','brown','pink','liolgr','libg'};
nclus=ncol(unique(clusname));
ncoul=nrow(colors);
if nclus> ncoul then
do;
   print " " /;
   print "----------------------------------------------------------";
   print "                  ** AVERTISSEMENT **                     ";
   print " LE NOMBRE DE CLUSTERS > LE NOMBRE DE COULEURS DISPONIBLES";
   print "----------------------------------------------------------";
   return;
end;
b={0 0 1 1}; a=j(1,4,0);
call gstart(gkat,1); call gopen("CLUSCOZ",0,titre);
call gstrlen(l,titre);
call gscript(50-l/2,97,titre,,,1.25,'swissb','r');
do i=1 to m;
  do j= 1 to n;
    a[1]=(j-1)*ph; a[2]=95.25-i*pv;
    a[3]=j*ph;     a[4]=95.25-(i-1)*pv;
    call gwindow(b); call gport(a); k=(j-1)*m+i;
    x=loc(idobs=concat("No",char(k,taille(m*n))));
    jj=cluster[x]; coul=colors[jj];
    call gpoly(xbox,ybox,,'black','solid',coul);
  end;
end;
call gclose; call gshow("CLUSCOZ"); call gstop;
finish cluscoz;
store module=cluscoz;
