%*libname k 'c:\k7\akor';
options nocenter nodate ls=78  ps=200 mprint SASMSTORE=k mstored;
%window surclass  rows=31  color=cyan
#1 @20 "Pour abandonner taper O dans le champ STOP =" +1 stop 1 attr=rev_video
#3 @20 "COMPLEMENTS TOUT PROGRAMME POUR UNE GRILLE" color=magenta
#4 @20 "=>>> PAVAGE EN SUPER CLASSES (CLUSTERS)"  attr=underline
#6 @3 "nom de la librairie	   (par defaut c:\k7\aboul) "
#7 @3 "nom commun		   (par defaut _TEMPOR_) "
#8 @3 "type du catalogue     (3 solutions pour ???? : GACP ou GKOR ou GACM)"
#9 @3 "nombre de super-classes	   (par defaut 3) "
#13 @10 "librairie  :" +2 lib 40 attr=rev_video
#15 @10 "nom commun :" +2 nom  8 attr=rev_video
#17 @10 "type du catalogue :" +2 typ 4 attr=rev_video
#19 @10 "nombre de super-classes :" +2 nc 2 attr=rev_video
#25 @63 "Valider vos choix avec la touche F3" color=magenta
#26 @37 "En cas de NON sortie consulter les messages de la fenetre LOG "
	 color=magenta;
%macro mklug / store des="Pavage (gri) en super classes (clusters)";
%local nom typ err stop lib tabws catiml gcat nc ok ok1 ok2 ok3 ok4 ok5 ok6;
%let err=0; %let stop=; %let lib=c:\k7\aboul; %let typ=????; %let nom=_TEMPOR_;
%let nc=3; %let ok=0; %let ok1=0; %let ok2=0; %let ok3=0;
%let ok4=0; %let ok5=0; %let ok6=0;
%do %until(&ok=1);
%display surclass;
%let stop=%upcase(&stop); %if &stop=  %then %let ok6=1;
%if &stop=O %then %goto arret; %if &stop^=O and &stop^=  %then	%do;
    %let ok6=0; %put ne taper pas  &stop mais O pour abandonner; %goto test; %end;
%str(libname a "&lib";);
%if  (%sysfunc(libref(a))) %then %put %str(le repertoire &lib n%'existe pas !);
%let nom=%upcase(&nom);
%if %length(&nom)<5
%then  %do j=1 %to %eval(5-%length(&nom)); %let nom=&nom.X; %end;
%let catiml=a.&nom;
%if  %sysfunc(cexist(&catiml)) %then %let ok1=1;
			       %else
%do; %put %str(le catalogue iml &catiml n%'existe pas !); %let ok1=0; %end;
%let typ=%upcase(&typ);
%if &typ=GACP or &typ=GACM or &typ=GKOR
	%then %let ok2=1;
	%else %let ok2=0;
%let gcat=a.&typ%substr(&nom,1,4);
%if %sysfunc(cexist(&gcat)) %then %let ok3=1;
			    %else
%do; %put %str(le catalogue graphique &gcat n%'existe pas !); %let ok3=0; %end;
%let tabws=a.%substr(&nom,1,5)_WS;
%if  %sysfunc(exist(&tabws)) %then %let ok5=1;
			     %else
%do; %put %str(la table sas &tabws n%'existe pas !); %let ok5=0; %end;
%if &nc>0 %then %let ok4=1;
	  %else
%do; %put %str(la valeur &nc n%'est pas correcte !); %let ok4=0; %end;
%test: %put %str();
%if &ok1=1 and &ok2=1 and &ok3=1 and &ok4=1 and &ok5=1 and &ok6=1
%then %let ok=1;
%else
%do; %let stop=; %let lib=c:\k7\aboul;
     %let typ=????; %let nom=_TEMPOR_; %let nc=3; %end;
%end;
%str(libname a "&lib";); libname k 'c:\k7\akor';
proc contents data=&tabws out=out noprint;
data out; set out; keep name varnum;
proc sql noprint; select varnum  into :vf from out
			where upcase(name)='EFFECTIF'; quit;
%if &vf^=4 %then %do;
%put Vous devez utiliser mkluf1 ou mkluf2 avec une ficelle; %goto arret; %end;
data tws; set &tabws; drop ligne colonne effectif;
PROC  CLUSTER  DATA=tws
METHOD=WARD  OUTTREE=t; ID idobs; RUN;
PROC TREE DATA=t NOPRINT OUT=p	 NCL=&nc; ID idobs; RUN;
proc sql; create table a.CLUST&nc as  select cluster, u.*
from p as c, tws as u where c.idobs=u.idobs;
quit;
proc iml;
reset storage=&catiml; load; reset storage=k.kouto;
load module=(dendroyg cluspav cluscoul cluspaz cluscoz cluscolt clusdist clusdima);
reset storage=k.kompa; load module=(taille grivois mintra);
GOPTIONS GUNIT=PCT;
run dendroyg('t','G_Dendrogramme',gkat);
GOPTIONS GUNIT=CELL;
%let title=" Pavage en &nc Super_classes";
%let titre=" &nc Super_classes avec les Representants";
%let titr2=" &nc Super_classes avec les Proches Voisins";
if upcase(substr(act,1,10))='KACP : GRI' |
			upcase(substr(act,1,10))='KACM : GRI'
	then run clusdima('p',ee,ws,code,m,n,gkat,&titr2);
if upcase(substr(act,1,13))='KORRESP : GRI' |
			upcase(substr(act,1,11))='KDISJ : GRI'
	then run clusdist('p',ws,m,n,gkat,&titr2);
if upcase(substr(act,1,11))='KACM1 : GRI'
	then run clusdima('p',ee,ws,codD,m,n,gkat,&titr2);
if upcase(substr(act,1,11))='KACM2 : GRI'
	then run clusdima('p',ee,ws,codB,m,n,gkat,&titr2);

 if dimw<=50
	then  do;
		run cluspav('p',ws,m,n,gkat,&titre);
		run cluscoul('p',ws,m,n,gkat,&titre);
	      end;
	else
		run cluspaz('p',m,n,gkat,&title);
run cluscoz('p',m,n,gkat,&title);
if upcase(substr(act,1,11))='KDISJ : GRI'
	then run cluscolt('p',codq,idlig,m,n,gkat);
run cluscolt('p',code,label,m,n,gkat);
quit;
%arret : %put FIN DE LA MACRO;
%mend mklug;
