%*libname k 'c:\k7\akor';
options nocenter nodate ls=78  ps=200 mprint SASMSTORE=k mstored;
%window escaling  rows=26 color=cyan
#1 @20 "Pour abandonner taper O dans le champ STOP =" +1 stop 1 attr=rev_video
#3 @20 "COMPLEMENTS TOUT PROGRAMME ET TOUTE STRUCTURE" color=magenta
#4 @20 "=>>> SCALING DES DISTANCES EUCLIDIENNES ENTRE LES UNITES GAGNANTES"
        attr=underline
#6 @3 "nom de la librairie         (par defaut c:\k7\aboul) "
#7 @3 "nom commun                  (par defaut _TEMPOR_) "
#8 @3 "type du catalogue     (3 solutions pour ???? : GACP ou GKOR ou GACM)"
#11 @10 "librairie  :" +2 lib 40 attr=rev_video
#13 @10 "nom commun :" +2 nom  8 attr=rev_video
#15 @10 "type du catalogue :" +2 typ 4 attr=rev_video
#20 @63 "Valider vos choix avec la touche F3" color=magenta
#21 @37 "En cas de NON sortie consulter les messages de la fenetre LOG "
         color=magenta;
%macro mscal / store des="Scaling dist. Euclid. entre les gagnants";
%local lib nom typ stop tabws catiml tad gcat ok ok1 ok2 ok3 ok4 ok5;
%let stop=; %let lib=c:\k7\aboul; %let nom=_TEMPOR_; %let typ=????;
%let ok=0; %let ok1=0; %let ok2=0; %let ok3=0; %let ok4=0; %let ok5=0;
%do %until(&ok=1);
%display escaling;
%let stop=%upcase(&stop); %if &stop=  %then %let ok4=1;
%if &stop=O %then %goto arret;
%if &stop^=O and &stop^=  %then
        %do;
        %let ok4=0;
        %put ne taper pas &stop mais O pour abandonner;
        %goto test;
        %end;
%str(libname a "&lib";);
%if (%sysfunc(libref(a))) %then %put %str(le repertoire &lib n%'existe pas !);
%let nom=%upcase(&nom); %if %length(&nom)<5
%then  %do j=1 %to %eval(5-%length(&nom)); %let nom=&nom.X; %end;
%let catiml=a.&nom;
%if %sysfunc(cexist(&catiml)) %then %let ok1=1;
                              %else
%do; %put %str(le catalogue iml &catiml n%'existe pas !); %let ok1=0; %end;
%let typ=%upcase(&typ);
%if &typ=GACP or &typ=GACM or &typ=GKOR
                %then %let ok2=1; %else %let ok2=0;
%let gcat=a.&typ%substr(&nom,1,4);
%if %sysfunc(cexist(&gcat)) %then %let ok3=1;
                            %else
%do; %put %str(le catalogue graphique &gcat n%'existe pas !); %let ok3=0; %end;
%let tabws=a.%substr(&nom,1,5)_WS; %if  %sysfunc(exist(&tabws)) %then %let ok5=1;
     %else %do; %put %str(la table sas &tabws n%'existe pas !); %let ok5=0; %end;
%test: %put %str();
%if &ok1=1 and &ok2=1 and &ok3=1 and &ok4=1 and &ok5=1 %then %let ok=1;
%else %do; %let stop=; %let lib=c:\k7\aboul; %let typ=????; %let nom=_TEMPOR_; %end;
%end;
%str(libname a "&lib";); libname k 'c:\k7\akor';
proc contents data=&tabws out=ut noprint;
data ut; set ut; keep name varnum;
proc sql noprint; select varnum  into :vf from ut
                                        where upcase(name)='EFFECTIF'; quit;
proc iml;
reset storage=k.kompa; load module=taille;
reset storage=k.kouto; load module=deug; reset storage=&catiml; load;
%let tad=%substr(&catiml,3,5); %let tad=&tad._EG;
run deug('a','&tad',ws,icl);
quit;
proc contents data=a.&tad out=oo noprint;
data oo; set oo; keep name varnum;
proc sql noprint; select max(varnum)  into :nug  from oo ;
quit;
%if &nug<=3 %then
        %do;
                %put Il faut au moins 3 unites gagnantes pour le MDS;
                %goto arret;
        %end;
proc mds data=a.&tad level=a out=e nop; id cell;
data ee; set e(firstobs=2 keep=cell dim1 dim2);
data anne; set ee; retain xsys ysys '2';
text=cell; x=dim1; y=dim2;
function='label'; color='red';
size=1.125; style='swissb';
%if &vf=4 %then         %do;
proc gplot annotate=anne gout=&gcat; symbol v=none I=none;
  plot y*x /name='ESCALING' fr des='Scaling (E) des Gagnants';
  title j=c h=2 c=red f=swissb " SCALING (E) en 2D ";
  run; title; quit;
                        %end;
%if &vf=2 %then         %do;
proc gplot annotate=anne gout=&gcat; symbol v=none I=join CI=red w=1; 
  plot y*x /name='ESCALING' fr des='Scaling (E) des Gagnants';
  title j=c h=2 c=red f=swissb " SCALING (E) en 2D ";
  run; title; quit;
                        %end;
%arret : %put FIN DE LA MACRO;
%mend mscal;
