options nodate;
proc iml;
 START kolclus(VNAME,fract);
if fract>.5 then fract=.45;
colors={'lipk','vliv','lig','vlibg','lio','ligr','rose','steel',
        'paoy','vligb','ligrpr','vpav','lippk','pink','paypk','lilg',
        'lilac','vpag','brown','liybr','liolgr','libg'};
ncoul=nrow(colors);
titre='22 couleurs pour les Clusters';
call gstart("work.col22",0);
CALL GOPEN('clusters',1,titre);
NV=NCOL(VNAME); IF (NV = 1) THEN NV = NROW(VNAME);
CELLWID=INT(90/NV);  DIST=fract*CELLWID;
WIDTH = CELLWID - 2*DIST;
XSTART = INT((90 -CELLWID * NV)/2) + 5;
XGRID = ((0:NV)#CELLWID + XSTART)`;
    cell1= J(NV+1, 1, Xgrid[nv+1]); CELL1 = XGRID || cell1;
    CELL2 = J(NV+1, 1, XSTART); CELL2 = CELL1[,1] || CELL2;
    CALL GDRAWL(CELL1, CELL2);
    CALL GDRAWL(CELL1[,{2 1}], CELL2[,{2 1}]);
XSTART = XSTART + DIST;  YSTART = XGRID[NV] + DIST;
CALL GSET("HEIGHT",3.5);
CALL GSET("FONT","swissb");
CALL GSTRLEN(LEN, VNAME);
WHERE = XGRID[1:NV] + (CELLWID-LEN)/2;
CALL GSCRIPT(WHERE,0, VNAME,30) ;
CALL GSCRIPT(32,95,titre,,,4);
VP = (XSTART || YSTART) // ((XSTART || YSTART) + WIDTH) ;
HT =1.5*NV;  CALL GSET("HEIGHT", HT);
    DO I=1 TO NV;
       DO J=1 TO nv;
          CALL GPORTSTK(VP);
           /* traitement */
        if nv <= ncoul then
    do; call gpoly({0 90 0 0},{0 0 90 0},,colors[j],'s',colors[j]);
        call gpoly({10 100 100 10},{100 100 10 100 },,colors[j],'e',colors[j]);
    end;
          VP[,1] = VP[,1] + CELLWID;
          CALL GPORTPOP;
       END;
       VP =  (XSTART // XSTART + WIDTH) || (VP[,2] - CELLWID);
    END;
 call gwindow ({0 0 100 100});
 call gclose; CALL GSHOW('clusters'); call gstop;
FINISH kolclus;

GOPTIONS GUNIT=PCT;
colors={'lipk','vliv','lig','vlibg','lio','ligr','rose','steel',
        'paoy','vligb','ligrpr','vpav','lippk','pink','paypk','lilg',
        'lilac','vpag','brown','liybr','liolgr','libg'};
Couleurs=(1:nrow(colors))`;
print " " /;
print "==>> Les 22 couleurs pour les clusters";
print Couleurs[rowname=colors colname='Numero'];
RUN kolclus(colors,.1);
QUIT;
GOPTIONS GUNIT=CELL;
